import reader
import os
import json
from reader import calculate_error
#from parsepypybenchmarks import parse

f = open("../../pypy-benchmarks/speed_vs.json","r")
dump = json.loads(f.read())
results = dump['results']


f = open("data/speedup_pypy.dat", "w")

for b in results:
    name = b[0]
    print "fetching", name

    d = b[2]
    base = d['base_times'] # none
    change = d['changed_times'] # all
    if base is None or change is None:
        print "skipped", base, change
        continue

    f.write(name)

    avg_base = float(sum(base) / len(base))
    #err_base = calculate_error(base)
    avg_change = float(sum(change) / len(change))
    #err_change = calculate_error(change)

    speedup = avg_change / avg_base
    f.write(" %.4f" % speedup)
    f.write("\n")
f.close()

f = open("gpi/speedup_pypy.gpi", "w")
f.write("""
    red = "#ff2626"
    green = "#2dc800"
    blue = "#2faace"
    purple = "#8d18ab"
    turkis = "#4fbddd"
    yellow = "#ffbe28"

    set size 1,0.8

    set xtics nomirror rotate by -90
    set style fill solid border -1
    set style data histograms
    set boxwidth 1#0.9
    set yrange [0:1]
    set ylabel "Relative execution time"
    # define left/upper border
    #set style line 11 lc rgb '#808080' lt 1
    #set border 3 back ls 11
    # define grid
    set style line 12 lc rgb '#808080' lt 0 lw 1
    set grid noxtics ytics back ls 12
    set nokey
    plot 'data/speedup_pypy.dat' using 2:xtic(1) lt rgb "#000000"

    set terminal postscript eps color solid
    set output "eps/speedup_pypy.eps"
    replot
"""
)
f.close()

os.system("gnuplot gpi/speedup_pypy.gpi -persist")
#os.system("epstopdf eps/speedup_pypy.eps")
#os.system("cp eps/speedup_pypy.pdf /home/lukas/uni/memory_paper/images/")
